package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleDomainNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleDomainNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleDomainNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleDomainNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleDomainNode build(long ptr) {
		return new ISLScheduleDomainNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleDomainNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_from_domain 
	 * 
	@take domain
	 * @generated
	**/
	 public static ISLScheduleDomainNode buildFromDomain(ISLUnionSet domain) { 
		/*** PROTECTED REGION ID(static_isl_schedule_node_from_domain) DISABLED START ***/
		ISLScheduleDomainNode res;
		
		synchronized(LOCK) {
			checkParameters(domain);
			try {
				res = (ISLScheduleDomainNode)ISLScheduleDomainNode.build(ISLNative.isl_schedule_node_from_domain(getNativePtr(domain)));
			} finally {
				taken(domain);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_domain_get_domain 
	 * 
	 * @generated
	**/
	public ISLUnionSet getDomain() {
		/*** PROTECTED REGION ID(isl_schedule_node_domain_get_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_schedule_node_domain_get_domain(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleDomainNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleDomainNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
